// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------
// BlobResultDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Blobpattern.h"
#include "BlobResultDlg.h"
#include "BlobPatternDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBlobResultDlg _CAO


CBlobResultDlg::CBlobResultDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlobResultDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBlobResultDlg)
	m_result = _T("");
	m_blobno = _T("");
	m_allblobno = _T("");
	//}}AFX_DATA_INIT
	m_pi = 3.14159265358979; 
	m_lngBlobNo = -1;
}


void CBlobResultDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBlobResultDlg)
	DDX_Text(pDX, IDC_RESULT, m_result);
	DDX_Text(pDX, IDC_BLOBNO, m_blobno);
	DDX_Text(pDX, IDC_ALLBLOBNO, m_allblobno);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBlobResultDlg, CDialog)
	//{{AFX_MSG_MAP(CBlobResultDlg)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	ON_BN_CLICKED(IDC_SETPATTERN, OnSetpattern)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlobResultDlg bZ[W nh

BOOL CBlobResultDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
    m_lngBlobNo = 0;
    m_allblobno.Format( "%d" , m_lngMaxBlobNo );
    DrawOne( m_lngBlobNo );
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

// PBlob`
void CBlobResultDlg::DrawOne( int lngNum )
{

	IFvBlobResultPtr pBlobResult(__uuidof( FvBlobResult ));
	IFvRectangle2Ptr pBox(__uuidof( FvRectangle ));

	m_blobno.Format("%d",lngNum);
    
    // I[o[Cʂ̏
	m_parent->m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
        
    // ͈͂𔖐ŕ\
	m_parent->m_disp->m_FvxDisplayEx->PutPenColor( 0xC0C0FF );
	m_parent->m_disp->m_FvxDisplayEx->DrawData( 0, m_parent->m_BlobExeRegion );
    
    // u[uڍ׏擾
    m_parent->m_FvxBlob->GetResult( lngNum, pBlobResult );

    // u[ȕڍׂȏeLXg{bNXɕ\
    m_result.Format("܂܂Ȃʐ : %d\r\n\
 :  %d\r\n\
͒ : %d\r\n\
ȉ~厲 : %.2f\r\n\
ȉ~ : %.2f\r\n\
ȉ~XΊp : %.2f\r\n\
dSW : ( %.2f , %.2f )\r\n\
Xŏl : %d\r\n\
Xől : %d\r\n\
Yŏl : %d\r\n\
Yől : %d\r\n\
܂߂ʐ : %d\r\n\
Oڒ`  : ( %.2f , %.2f )\r\n\
Oڒ` E : ( %.2f , %.2f )\r\n\
Oڒ`  : ( %.2f , %.2f )\r\n\
Oڒ` E : ( %.2f , %.2f )\r\n",
					pBlobResult->Getarea(),
					pBlobResult->Gethole_num(),
					pBlobResult->Getperim(),
					pBlobResult->Getellipse_long(),
					pBlobResult->Getellipse_short(),
					pBlobResult->Getellipse_angle(),
					pBlobResult->Getcenter_x(),
					pBlobResult->Getcenter_y(),
					pBlobResult->Getx_min(),
					pBlobResult->Getx_max(),
					pBlobResult->Gety_min(),
					pBlobResult->Gety_max(),
					pBlobResult->Gettotal_area(),
					pBlobResult->Getbounding_top_x(),
					pBlobResult->Getbounding_top_y(),
					pBlobResult->Getbounding_right_x(),
					pBlobResult->Getbounding_right_y(),
					pBlobResult->Getbounding_left_x(),
					pBlobResult->Getbounding_left_y(),
					pBlobResult->Getbounding_bottom_x(),
					pBlobResult->Getbounding_bottom_y());

    // F = 
    m_parent->m_disp->m_FvxDisplayEx->PutPenColor( 0xFF0000 );

    // tFa\
    pBox->Putxs( pBlobResult->Getx_min() );
    pBox->Putys( pBlobResult->Gety_min() );
    pBox->Putxe( pBlobResult->Getx_max() );
    pBox->Putye( pBlobResult->Gety_max() );
    
    m_parent->m_disp->m_FvxDisplayEx->DrawData( 0, pBox );

	UpdateData( FALSE );

}


// 
void CBlobResultDlg::OnNext() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );
    m_lngBlobNo = m_lngBlobNo + 1;
    if ( m_lngBlobNo > m_lngMaxBlobNo ) m_lngBlobNo = m_lngMaxBlobNo;
    DrawOne( m_lngBlobNo );
	
}

// O
void CBlobResultDlg::OnBack() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );
    m_lngBlobNo = m_lngBlobNo - 1;
    if ( m_lngBlobNo < 0 ) m_lngBlobNo = 0 ;
    DrawOne( m_lngBlobNo );
	
}

void CBlobResultDlg::OnCancel() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// _CAOI
	EndDialog( IDOK );
}

// p^o^ďI
void CBlobResultDlg::OnSetpattern() 
{

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	IFvBlobResultPtr pBlobResult(__uuidof( FvBlobResult ));
	IFvRectangle2Ptr pBox(__uuidof( FvRectangle ));
	IFvPointPtr pPoint(__uuidof( FvPoint ));

    // u[uڍ׏擾
	m_parent->m_FvxBlob->GetResult( m_lngBlobNo , pBlobResult );

    pBox->Putxs( pBlobResult->Getx_min() );
    pBox->Putys( pBlobResult->Gety_min() );
    pBox->Putxe( pBlobResult->Getx_max() );
    pBox->Putye( pBlobResult->Gety_max() );

    // 񓚊_p^̈̒ɐݒ
    pPoint->Putx((pBlobResult->Getx_min() + pBlobResult->Getx_max()) / 2);
    pPoint->Puty((pBlobResult->Gety_min() + pBlobResult->Gety_max()) / 2);
    
    m_parent->m_FvxPattern->MakePattern( m_parent->m_FvxImageGray , pBox , pPoint );
    
	// _CAOI
	EndDialog( IDOK );
	
}
